package handler

import (
	"context"
	"eslogad-be/internal/contract"
	"eslogad-be/internal/manager"

	"github.com/google/uuid"
)

type UserService interface {
	CreateUser(ctx context.Context, req *contract.CreateUserRequest) (*contract.UserResponse, error)
	BulkCreateUsers(ctx context.Context, req *contract.BulkCreateUsersRequest) (*contract.BulkCreateUsersResponse, error)
	BulkCreateUsersAsync(ctx context.Context, req *contract.BulkCreateUsersRequest) (*contract.BulkCreateAsyncResponse, error)
	GetBulkJobStatus(ctx context.Context, jobID uuid.UUID) (*manager.BulkJobResult, error)
	UpdateUser(ctx context.Context, id uuid.UUID, req *contract.UpdateUserRequest) (*contract.UserResponse, error)
	DeleteUser(ctx context.Context, id uuid.UUID) error
	GetUserByID(ctx context.Context, id uuid.UUID) (*contract.UserResponse, error)
	GetUserByEmail(ctx context.Context, email string) (*contract.UserResponse, error)
	ListUsers(ctx context.Context, req *contract.ListUsersRequest) (*contract.ListUsersResponse, error)
	ChangePassword(ctx context.Context, userID uuid.UUID, req *contract.ChangePasswordRequest) error

	GetProfile(ctx context.Context, userID uuid.UUID) (*contract.UserProfileResponse, error)
	UpdateProfile(ctx context.Context, userID uuid.UUID, req *contract.UpdateUserProfileRequest) (*contract.UserProfileResponse, error)

	ListTitles(ctx context.Context) (*contract.ListTitlesResponse, error)

	GetActiveUsersForMention(ctx context.Context, search *string, limit int) ([]contract.UserResponse, error)
}
